﻿<?xml version="1.0" encoding="utf-8"?>
<Dsl xmlns:dm0="http://schemas.microsoft.com/VisualStudio/2008/DslTools/Core" dslVersion="1.0.0.0" Id="2f370e1e-a304-4282-bce5-06dfe499725c" Description="Description for Company.School.School" Name="School" DisplayName="School" Namespace="Company.School" ProductName="School" CompanyName="Company" PackageGuid="f7466f51-a073-4b52-92cf-e8369b87a69d" PackageNamespace="Company.School" xmlns="http://schemas.microsoft.com/VisualStudio/2005/DslTools/DslDefinitionModel">
  <Classes>
    <DomainClass Id="4241c694-4a58-4a81-becc-3310d9bbfdbf" Description="The root in which all other elements are embedded. Appears as a diagram." Name="SchoolModel" DisplayName="School Model" Namespace="Company.School">
      <ElementMergeDirectives>
        <ElementMergeDirective>
          <Index>
            <DomainClassMoniker Name="Student" />
          </Index>
          <LinkCreationPaths>
            <DomainPath>SchoolModelHasStudent.Student</DomainPath>
          </LinkCreationPaths>
        </ElementMergeDirective>
      </ElementMergeDirectives>
    </DomainClass>
    <DomainClass Id="ccd6052f-86d3-421c-b94e-effd67dd7337" Description="Elements embedded in the model. Appear as boxes on the diagram." Name="Student" DisplayName="Student" InheritanceModifier="Abstract" Namespace="Company.School">
      <Properties>
        <DomainProperty Id="93a6d253-ca68-4e13-a6ff-b543f406652f" Description="Description for Company.School.Student.Name" Name="Name" DisplayName="Name" DefaultValue="" IsElementName="true">
          <Type>
            <ExternalTypeMoniker Name="/System/String" />
          </Type>
        </DomainProperty>
        <DomainProperty Id="cfd82d33-78c2-46fb-8291-a61bd8bee184" Description="Description for Company.School.Student.ID" Name="ID" DisplayName="ID">
          <Type>
            <ExternalTypeMoniker Name="/System/String" />
          </Type>
        </DomainProperty>
        <DomainProperty Id="ea99bec0-9884-4384-99bd-b0eef57c0138" Description="Description for Company.School.Student.Birthday" Name="Birthday" DisplayName="Birthday">
          <Type>
            <ExternalTypeMoniker Name="/System/DateTime" />
          </Type>
        </DomainProperty>
      </Properties>
    </DomainClass>
    <DomainClass Id="b3a992ec-199d-4272-9f66-d24630590cb0" Description="Description for Company.School.Male" Name="Male" DisplayName="Male" Namespace="Company.School">
      <BaseClass>
        <DomainClassMoniker Name="Student" />
      </BaseClass>
    </DomainClass>
    <DomainClass Id="f068c013-759b-46a5-a013-c02d7685d70f" Description="Description for Company.School.Female" Name="Female" DisplayName="Female" Namespace="Company.School">
      <BaseClass>
        <DomainClassMoniker Name="Student" />
      </BaseClass>
    </DomainClass>
  </Classes>
  <Relationships>
    <DomainRelationship Id="7e1ccc38-589a-4695-9637-2577b3d3e521" Description="Description for Company.School.SchoolModelHasStudent" Name="SchoolModelHasStudent" DisplayName="School Model Has Student" Namespace="Company.School" IsEmbedding="true">
      <Source>
        <DomainRole Id="f04aa0ed-f832-4fca-94bc-7b1fe3a5e95c" Description="Description for Company.School.SchoolModelHasStudent.SchoolModel" Name="SchoolModel" DisplayName="School Model" PropertyName="Student" PropagatesCopy="PropagatesCopyToLinkAndOppositeRolePlayer" PropertyDisplayName="Student">
          <RolePlayer>
            <DomainClassMoniker Name="SchoolModel" />
          </RolePlayer>
        </DomainRole>
      </Source>
      <Target>
        <DomainRole Id="2199847c-932d-4a8c-9e04-e95a3e2bbf93" Description="Description for Company.School.SchoolModelHasStudent.Student" Name="Student" DisplayName="Student" PropertyName="SchoolModel" Multiplicity="One" PropagatesDelete="true" PropertyDisplayName="School Model">
          <RolePlayer>
            <DomainClassMoniker Name="Student" />
          </RolePlayer>
        </DomainRole>
      </Target>
    </DomainRelationship>
    <DomainRelationship Id="0a5f54eb-da45-46f7-88bc-8b48d59087a4" Description="Description for Company.School.StudentReferencesTargetStudent" Name="StudentReferencesTargetStudent" DisplayName="Student References Target Student" Namespace="Company.School">
      <Properties>
        <DomainProperty Id="7760fb83-aea7-4221-b2e7-8ac70f377e41" Description="Description for Company.School.StudentReferencesTargetStudent.关系" Name="关系" DisplayName="关系">
          <Type>
            <ExternalTypeMoniker Name="/System/String" />
          </Type>
        </DomainProperty>
      </Properties>
      <Source>
        <DomainRole Id="4e4e1842-9356-4f62-bb73-b86625ab6744" Description="Description for Company.School.StudentReferencesTargetStudent.SourceStudent" Name="SourceStudent" DisplayName="Source Student" PropertyName="TargetStudent" PropertyDisplayName="Target Student">
          <RolePlayer>
            <DomainClassMoniker Name="Student" />
          </RolePlayer>
        </DomainRole>
      </Source>
      <Target>
        <DomainRole Id="57fd79bc-a772-457a-a5f6-88aee949fcb1" Description="Description for Company.School.StudentReferencesTargetStudent.TargetStudent" Name="TargetStudent" DisplayName="Target Student" PropertyName="SourceStudent" PropertyDisplayName="Source Student">
          <RolePlayer>
            <DomainClassMoniker Name="Student" />
          </RolePlayer>
        </DomainRole>
      </Target>
    </DomainRelationship>
  </Relationships>
  <Types>
    <ExternalType Name="DateTime" Namespace="System" />
    <ExternalType Name="String" Namespace="System" />
    <ExternalType Name="Int16" Namespace="System" />
    <ExternalType Name="Int32" Namespace="System" />
    <ExternalType Name="Int64" Namespace="System" />
    <ExternalType Name="UInt16" Namespace="System" />
    <ExternalType Name="UInt32" Namespace="System" />
    <ExternalType Name="UInt64" Namespace="System" />
    <ExternalType Name="SByte" Namespace="System" />
    <ExternalType Name="Byte" Namespace="System" />
    <ExternalType Name="Double" Namespace="System" />
    <ExternalType Name="Single" Namespace="System" />
    <ExternalType Name="Guid" Namespace="System" />
    <ExternalType Name="Boolean" Namespace="System" />
    <ExternalType Name="Char" Namespace="System" />
  </Types>
  <Shapes>
    <GeometryShape Id="e180c50d-3a46-4a83-9e7a-2b5e1f3c7b80" Description="Description for Company.School.MaleShape" Name="MaleShape" DisplayName="Male Shape" Namespace="Company.School" FixedTooltipText="Male Shape" InitialHeight="1" Geometry="Rectangle">
      <ShapeHasDecorators Position="Center" HorizontalOffset="0" VerticalOffset="0">
        <TextDecorator Name="NameTextDecorator" DisplayName="Name Text Decorator" DefaultText="NameTextDecorator" />
      </ShapeHasDecorators>
    </GeometryShape>
    <GeometryShape Id="cfcc4f21-9bbd-45d5-aa70-6470a5e760c1" Description="Description for Company.School.FemaleShape" Name="FemaleShape" DisplayName="Female Shape" Namespace="Company.School" FixedTooltipText="Female Shape" InitialHeight="1" Geometry="RoundedRectangle">
      <ShapeHasDecorators Position="Center" HorizontalOffset="0" VerticalOffset="0">
        <TextDecorator Name="NameTextDecorator" DisplayName="Name Text Decorator" DefaultText="NameTextDecorator" />
      </ShapeHasDecorators>
    </GeometryShape>
  </Shapes>
  <Connectors>
    <Connector Id="e0639b1e-cd65-405d-8625-7c05b1a39bb3" Description="Connector between the ExampleShapes. Represents ExampleRelationships on the Diagram." Name="StudentConnector" DisplayName="Student Connector" Namespace="Company.School" FixedTooltipText="Student Connector" Color="113, 111, 110" Thickness="0.01">
      <ConnectorHasDecorators Position="SourceTop" OffsetFromShape="0" OffsetFromLine="0">
        <TextDecorator Name="TextDecorator1" DisplayName="Text Decorator1" DefaultText="TextDecorator1" />
      </ConnectorHasDecorators>
    </Connector>
  </Connectors>
  <XmlSerializationBehavior Name="SchoolSerializationBehavior" Namespace="Company.School">
    <ClassData>
      <XmlClassData TypeName="SchoolModel" MonikerAttributeName="" SerializeId="true" MonikerElementName="schoolModelMoniker" ElementName="schoolModel" MonikerTypeName="SchoolModelMoniker">
        <DomainClassMoniker Name="SchoolModel" />
        <ElementData>
          <XmlRelationshipData UseFullForm="true" RoleElementName="student">
            <DomainRelationshipMoniker Name="SchoolModelHasStudent" />
          </XmlRelationshipData>
        </ElementData>
      </XmlClassData>
      <XmlClassData TypeName="Student" MonikerAttributeName="name" SerializeId="true" MonikerElementName="studentMoniker" ElementName="student" MonikerTypeName="StudentMoniker">
        <DomainClassMoniker Name="Student" />
        <ElementData>
          <XmlPropertyData XmlName="name" IsMonikerKey="true">
            <DomainPropertyMoniker Name="Student/Name" />
          </XmlPropertyData>
          <XmlPropertyData XmlName="iD">
            <DomainPropertyMoniker Name="Student/ID" />
          </XmlPropertyData>
          <XmlPropertyData XmlName="birthday">
            <DomainPropertyMoniker Name="Student/Birthday" />
          </XmlPropertyData>
          <XmlRelationshipData UseFullForm="true" RoleElementName="targetStudent">
            <DomainRelationshipMoniker Name="StudentReferencesTargetStudent" />
          </XmlRelationshipData>
        </ElementData>
      </XmlClassData>
      <XmlClassData TypeName="StudentConnector" MonikerAttributeName="" SerializeId="true" MonikerElementName="studentConnectorMoniker" ElementName="studentConnector" MonikerTypeName="StudentConnectorMoniker">
        <ConnectorMoniker Name="StudentConnector" />
      </XmlClassData>
      <XmlClassData TypeName="SchoolDiagram" MonikerAttributeName="" SerializeId="true" MonikerElementName="schoolDiagramMoniker" ElementName="schoolDiagram" MonikerTypeName="SchoolDiagramMoniker">
        <DiagramMoniker Name="SchoolDiagram" />
      </XmlClassData>
      <XmlClassData TypeName="Male" MonikerAttributeName="" SerializeId="true" MonikerElementName="maleMoniker" ElementName="male" MonikerTypeName="MaleMoniker">
        <DomainClassMoniker Name="Male" />
      </XmlClassData>
      <XmlClassData TypeName="Female" MonikerAttributeName="" SerializeId="true" MonikerElementName="femaleMoniker" ElementName="female" MonikerTypeName="FemaleMoniker">
        <DomainClassMoniker Name="Female" />
      </XmlClassData>
      <XmlClassData TypeName="SchoolModelHasStudent" MonikerAttributeName="" SerializeId="true" MonikerElementName="schoolModelHasStudentMoniker" ElementName="schoolModelHasStudent" MonikerTypeName="SchoolModelHasStudentMoniker">
        <DomainRelationshipMoniker Name="SchoolModelHasStudent" />
      </XmlClassData>
      <XmlClassData TypeName="StudentReferencesTargetStudent" MonikerAttributeName="" SerializeId="true" MonikerElementName="studentReferencesTargetStudentMoniker" ElementName="studentReferencesTargetStudent" MonikerTypeName="StudentReferencesTargetStudentMoniker">
        <DomainRelationshipMoniker Name="StudentReferencesTargetStudent" />
        <ElementData>
          <XmlPropertyData XmlName="关系">
            <DomainPropertyMoniker Name="StudentReferencesTargetStudent/关系" />
          </XmlPropertyData>
        </ElementData>
      </XmlClassData>
      <XmlClassData TypeName="MaleShape" MonikerAttributeName="" SerializeId="true" MonikerElementName="maleShapeMoniker" ElementName="maleShape" MonikerTypeName="MaleShapeMoniker">
        <GeometryShapeMoniker Name="MaleShape" />
      </XmlClassData>
      <XmlClassData TypeName="FemaleShape" MonikerAttributeName="" SerializeId="true" MonikerElementName="femaleShapeMoniker" ElementName="femaleShape" MonikerTypeName="FemaleShapeMoniker">
        <GeometryShapeMoniker Name="FemaleShape" />
      </XmlClassData>
    </ClassData>
  </XmlSerializationBehavior>
  <ExplorerBehavior Name="SchoolExplorer" />
  <ConnectionBuilders>
    <ConnectionBuilder Name="StudentReferencesTargetStudentBuilder">
      <LinkConnectDirective>
        <DomainRelationshipMoniker Name="StudentReferencesTargetStudent" />
        <SourceDirectives>
          <RolePlayerConnectDirective>
            <AcceptingClass>
              <DomainClassMoniker Name="Student" />
            </AcceptingClass>
          </RolePlayerConnectDirective>
        </SourceDirectives>
        <TargetDirectives>
          <RolePlayerConnectDirective>
            <AcceptingClass>
              <DomainClassMoniker Name="Student" />
            </AcceptingClass>
          </RolePlayerConnectDirective>
        </TargetDirectives>
      </LinkConnectDirective>
    </ConnectionBuilder>
  </ConnectionBuilders>
  <Diagram Id="b58ec26b-bdc6-45cd-8a28-1e76273f5c09" Description="Description for Company.School.SchoolDiagram" Name="SchoolDiagram" DisplayName="Minimal Language Diagram" Namespace="Company.School">
    <Class>
      <DomainClassMoniker Name="SchoolModel" />
    </Class>
    <ShapeMaps>
      <ShapeMap>
        <DomainClassMoniker Name="Male" />
        <ParentElementPath>
          <DomainPath>SchoolModelHasStudent.SchoolModel/!SchoolModel</DomainPath>
        </ParentElementPath>
        <DecoratorMap>
          <TextDecoratorMoniker Name="MaleShape/NameTextDecorator" />
          <PropertyDisplayed>
            <PropertyPath>
              <DomainPropertyMoniker Name="Student/Name" />
            </PropertyPath>
          </PropertyDisplayed>
        </DecoratorMap>
        <GeometryShapeMoniker Name="MaleShape" />
      </ShapeMap>
      <ShapeMap>
        <DomainClassMoniker Name="Female" />
        <ParentElementPath>
          <DomainPath>SchoolModelHasStudent.SchoolModel/!SchoolModel</DomainPath>
        </ParentElementPath>
        <DecoratorMap>
          <TextDecoratorMoniker Name="FemaleShape/NameTextDecorator" />
          <PropertyDisplayed>
            <PropertyPath>
              <DomainPropertyMoniker Name="Student/Name" />
            </PropertyPath>
          </PropertyDisplayed>
        </DecoratorMap>
        <GeometryShapeMoniker Name="FemaleShape" />
      </ShapeMap>
    </ShapeMaps>
    <ConnectorMaps>
      <ConnectorMap>
        <ConnectorMoniker Name="StudentConnector" />
        <DomainRelationshipMoniker Name="StudentReferencesTargetStudent" />
        <DecoratorMap>
          <TextDecoratorMoniker Name="StudentConnector/TextDecorator1" />
          <PropertyDisplayed>
            <PropertyPath>
              <DomainPropertyMoniker Name="StudentReferencesTargetStudent/关系" />
            </PropertyPath>
          </PropertyDisplayed>
        </DecoratorMap>
      </ConnectorMap>
    </ConnectorMaps>
  </Diagram>
  <Designer CopyPasteGeneration="CopyPasteOnly" FileExtension="mydsl11" EditorGuid="f35e5b0e-d49b-4e07-976c-56b8da1cf217">
    <RootClass>
      <DomainClassMoniker Name="SchoolModel" />
    </RootClass>
    <XmlSerializationDefinition CustomPostLoad="false">
      <XmlSerializationBehaviorMoniker Name="SchoolSerializationBehavior" />
    </XmlSerializationDefinition>
    <ToolboxTab TabText="School">
      <ElementTool Name="Male" ToolboxIcon="resources\exampleshapetoolbitmap.bmp" Caption="Male" Tooltip="Create an ExampleElement" HelpKeyword="CreateExampleClassF1Keyword">
        <DomainClassMoniker Name="Male" />
      </ElementTool>
      <ConnectionTool Name="StudentRelationship" ToolboxIcon="resources\exampleconnectortoolbitmap.bmp" Caption="StudentRelationship" Tooltip="Drag between ExampleElements to create an ExampleRelationship" HelpKeyword="ConnectExampleRelationF1Keyword">
        <ConnectionBuilderMoniker Name="School/StudentReferencesTargetStudentBuilder" />
      </ConnectionTool>
      <ElementTool Name="Female" ToolboxIcon="D:\讲课\DSL\Visual Studio 2010 DSL 开发与设计实践系列\Visual Studio 2010 DSL 开发与设计实践系列\图\Flow\TaskTool.bmp" Caption="Female" Tooltip="Female" HelpKeyword="Female">
        <DomainClassMoniker Name="Female" />
      </ElementTool>
    </ToolboxTab>
    <Validation UsesMenu="false" UsesOpen="false" UsesSave="false" UsesLoad="false" />
    <DiagramMoniker Name="SchoolDiagram" />
  </Designer>
  <Explorer ExplorerGuid="12a08ffb-acbe-45be-a3ff-01065cb48c0f" Title="School Explorer">
    <ExplorerBehaviorMoniker Name="School/SchoolExplorer" />
  </Explorer>
</Dsl>