﻿<?xml version="1.0" encoding="utf-8"?>
<Dsl xmlns:dm0="http://schemas.microsoft.com/VisualStudio/2008/DslTools/Core" dslVersion="1.0.0.0" Id="b64235d3-aaa2-44f6-b546-a1ff7c962d71" Description="Description for Company.Community.Community" Name="Community" DisplayName="Community" Namespace="Company.Community" ProductName="Community" CompanyName="Company" PackageGuid="7bc34bff-5c37-407e-8fed-a492db73a356" PackageNamespace="Company.Community" xmlns="http://schemas.microsoft.com/VisualStudio/2005/DslTools/DslDefinitionModel">
  <Classes>
    <DomainClass Id="78401fb5-3ae8-4884-bf61-92fbcf2dcf0d" Description="Description for Company.Community.CommunityModel" Name="CommunityModel" DisplayName="Community Model" Namespace="Company.Community">
      <ElementMergeDirectives>
        <ElementMergeDirective>
          <Index>
            <DomainClassMoniker Name="Family" />
          </Index>
          <LinkCreationPaths>
            <DomainPath>CommunityModelHasFamily.Family</DomainPath>
          </LinkCreationPaths>
        </ElementMergeDirective>
      </ElementMergeDirectives>
    </DomainClass>
    <DomainClass Id="a053a164-2dbb-454c-b87c-a66b08b4a65a" Description="Description for Company.Community.Family" Name="Family" DisplayName="Family" Namespace="Company.Community">
      <ElementMergeDirectives>
        <ElementMergeDirective>
          <Index>
            <DomainClassMoniker Name="Person" />
          </Index>
          <LinkCreationPaths>
            <DomainPath>FamilyHasPerson.Person</DomainPath>
          </LinkCreationPaths>
        </ElementMergeDirective>
      </ElementMergeDirectives>
    </DomainClass>
    <DomainClass Id="a3496b4e-6053-459d-8d16-2f2df6f5f1f2" Description="Description for Company.Community.Person" Name="Person" DisplayName="Person" Namespace="Company.Community" />
    <DomainClass Id="e47e4004-8fe4-4c54-8c61-32b57d95be11" Description="Description for Company.Community.Male" Name="Male" DisplayName="Male" Namespace="Company.Community">
      <BaseClass>
        <DomainClassMoniker Name="Person" />
      </BaseClass>
    </DomainClass>
    <DomainClass Id="c77ae609-1ee5-4dae-9f53-e8cdbe1f614e" Description="Description for Company.Community.Female" Name="Female" DisplayName="Female" Namespace="Company.Community">
      <BaseClass>
        <DomainClassMoniker Name="Person" />
      </BaseClass>
    </DomainClass>
  </Classes>
  <Relationships>
    <DomainRelationship Id="237da9b9-b77d-4528-a471-e16188c6626d" Description="Description for Company.Community.CommunityModelHasFamily" Name="CommunityModelHasFamily" DisplayName="Community Model Has Family" Namespace="Company.Community" IsEmbedding="true">
      <Source>
        <DomainRole Id="23989a08-48f6-4bc4-80b5-0ccce0d0fbac" Description="Description for Company.Community.CommunityModelHasFamily.CommunityModel" Name="CommunityModel" DisplayName="Community Model" PropertyName="Family" PropagatesCopy="PropagatesCopyToLinkAndOppositeRolePlayer" PropertyDisplayName="Family">
          <RolePlayer>
            <DomainClassMoniker Name="CommunityModel" />
          </RolePlayer>
        </DomainRole>
      </Source>
      <Target>
        <DomainRole Id="b58ebab4-1d6a-455e-bf7e-dfe7859ca033" Description="Description for Company.Community.CommunityModelHasFamily.Family" Name="Family" DisplayName="Family" PropertyName="CommunityModel" Multiplicity="One" PropagatesDelete="true" PropertyDisplayName="Community Model">
          <RolePlayer>
            <DomainClassMoniker Name="Family" />
          </RolePlayer>
        </DomainRole>
      </Target>
    </DomainRelationship>
    <DomainRelationship Id="d164c7c5-5a9a-43e4-9992-3f293c0fb266" Description="Description for Company.Community.FamilyHasPerson" Name="FamilyHasPerson" DisplayName="Family Has Person" Namespace="Company.Community" IsEmbedding="true">
      <Source>
        <DomainRole Id="b0888574-dc43-4692-9ddb-0dfb816ccc50" Description="Description for Company.Community.FamilyHasPerson.Family" Name="Family" DisplayName="Family" PropertyName="Person" PropagatesCopy="PropagatesCopyToLinkAndOppositeRolePlayer" PropertyDisplayName="Person">
          <RolePlayer>
            <DomainClassMoniker Name="Family" />
          </RolePlayer>
        </DomainRole>
      </Source>
      <Target>
        <DomainRole Id="635e913c-ff20-4a25-8cf0-34cbf1152565" Description="Description for Company.Community.FamilyHasPerson.Person" Name="Person" DisplayName="Person" PropertyName="Family" Multiplicity="One" PropagatesDelete="true" PropertyDisplayName="Family">
          <RolePlayer>
            <DomainClassMoniker Name="Person" />
          </RolePlayer>
        </DomainRole>
      </Target>
    </DomainRelationship>
  </Relationships>
  <Types>
    <ExternalType Name="DateTime" Namespace="System" />
    <ExternalType Name="String" Namespace="System" />
    <ExternalType Name="Int16" Namespace="System" />
    <ExternalType Name="Int32" Namespace="System" />
    <ExternalType Name="Int64" Namespace="System" />
    <ExternalType Name="UInt16" Namespace="System" />
    <ExternalType Name="UInt32" Namespace="System" />
    <ExternalType Name="UInt64" Namespace="System" />
    <ExternalType Name="SByte" Namespace="System" />
    <ExternalType Name="Byte" Namespace="System" />
    <ExternalType Name="Double" Namespace="System" />
    <ExternalType Name="Single" Namespace="System" />
    <ExternalType Name="Guid" Namespace="System" />
    <ExternalType Name="Boolean" Namespace="System" />
    <ExternalType Name="Char" Namespace="System" />
  </Types>
  <XmlSerializationBehavior Name="CommunitySerializationBehavior" Namespace="Company.Community">
    <ClassData>
      <XmlClassData TypeName="CommunityDiagram" MonikerAttributeName="" SerializeId="true" MonikerElementName="communityDiagramMoniker" ElementName="communityDiagram" MonikerTypeName="CommunityDiagramMoniker">
        <DiagramMoniker Name="CommunityDiagram" />
      </XmlClassData>
      <XmlClassData TypeName="CommunityModel" MonikerAttributeName="" SerializeId="true" MonikerElementName="communityModelMoniker" ElementName="communityModel" MonikerTypeName="CommunityModelMoniker">
        <DomainClassMoniker Name="CommunityModel" />
        <ElementData>
          <XmlRelationshipData UseFullForm="true" RoleElementName="family">
            <DomainRelationshipMoniker Name="CommunityModelHasFamily" />
          </XmlRelationshipData>
        </ElementData>
      </XmlClassData>
      <XmlClassData TypeName="Family" MonikerAttributeName="" SerializeId="true" MonikerElementName="familyMoniker" ElementName="family" MonikerTypeName="FamilyMoniker">
        <DomainClassMoniker Name="Family" />
        <ElementData>
          <XmlRelationshipData UseFullForm="true" RoleElementName="person">
            <DomainRelationshipMoniker Name="FamilyHasPerson" />
          </XmlRelationshipData>
        </ElementData>
      </XmlClassData>
      <XmlClassData TypeName="Person" MonikerAttributeName="" SerializeId="true" MonikerElementName="personMoniker" ElementName="person" MonikerTypeName="PersonMoniker">
        <DomainClassMoniker Name="Person" />
      </XmlClassData>
      <XmlClassData TypeName="CommunityModelHasFamily" MonikerAttributeName="" SerializeId="true" MonikerElementName="communityModelHasFamilyMoniker" ElementName="communityModelHasFamily" MonikerTypeName="CommunityModelHasFamilyMoniker">
        <DomainRelationshipMoniker Name="CommunityModelHasFamily" />
      </XmlClassData>
      <XmlClassData TypeName="FamilyHasPerson" MonikerAttributeName="" SerializeId="true" MonikerElementName="familyHasPersonMoniker" ElementName="familyHasPerson" MonikerTypeName="FamilyHasPersonMoniker">
        <DomainRelationshipMoniker Name="FamilyHasPerson" />
      </XmlClassData>
      <XmlClassData TypeName="Male" MonikerAttributeName="" SerializeId="true" MonikerElementName="maleMoniker" ElementName="male" MonikerTypeName="MaleMoniker">
        <DomainClassMoniker Name="Male" />
      </XmlClassData>
      <XmlClassData TypeName="Female" MonikerAttributeName="" SerializeId="true" MonikerElementName="femaleMoniker" ElementName="female" MonikerTypeName="FemaleMoniker">
        <DomainClassMoniker Name="Female" />
      </XmlClassData>
    </ClassData>
  </XmlSerializationBehavior>
  <ExplorerBehavior Name="CommunityExplorer" />
  <Diagram Id="555dbc63-bf90-4497-9b6a-847b72cf8ef2" Description="Description for Company.Community.CommunityDiagram" Name="CommunityDiagram" DisplayName="Minimal Language Diagram" Namespace="Company.Community">
    <Class>
      <DomainClassMoniker Name="CommunityModel" />
    </Class>
  </Diagram>
  <Designer CopyPasteGeneration="CopyPasteOnly" FileExtension="mydsl11" EditorGuid="68e5f0bf-b936-4f6a-a448-17590081a835">
    <RootClass>
      <DomainClassMoniker Name="CommunityModel" />
    </RootClass>
    <XmlSerializationDefinition CustomPostLoad="false">
      <XmlSerializationBehaviorMoniker Name="CommunitySerializationBehavior" />
    </XmlSerializationDefinition>
    <ToolboxTab TabText="Community" />
    <Validation UsesMenu="false" UsesOpen="false" UsesSave="false" UsesLoad="false" />
    <DiagramMoniker Name="CommunityDiagram" />
  </Designer>
  <Explorer ExplorerGuid="9efb54e8-b42f-419a-b275-b68c47e4153a" Title="Community Explorer">
    <ExplorerBehaviorMoniker Name="Community/CommunityExplorer" />
  </Explorer>
</Dsl>